diff --git a/lib/netdev-dpdk.c b/lib/netdev-dpdk.c
index d7350636e..e9b539197 100644
--- a/lib/netdev-dpdk.c
+++ b/lib/netdev-dpdk.c
@@ -4937,12 +4937,12 @@ netdev_dpdk_reconfigure(struct netdev *netdev)
 
     err = dpdk_eth_dev_init(dev);
     if (dev->hw_ol_features & NETDEV_TX_TSO_OFFLOAD) {
-        netdev->ol_flags |= NETDEV_TX_OFFLOAD_TCP_TSO;
-        netdev->ol_flags |= NETDEV_TX_OFFLOAD_TCP_CSUM;
-        netdev->ol_flags |= NETDEV_TX_OFFLOAD_UDP_CSUM;
-        netdev->ol_flags |= NETDEV_TX_OFFLOAD_IPV4_CSUM;
+        netdev->ol_flags |= NETDEV_OFFLOAD_TX_TCP_TSO;
+        netdev->ol_flags |= NETDEV_OFFLOAD_TX_TCP_CSUM;
+        netdev->ol_flags |= NETDEV_OFFLOAD_TX_UDP_CSUM;
+        netdev->ol_flags |= NETDEV_OFFLOAD_TX_IPV4_CSUM;
         if (dev->hw_ol_features & NETDEV_TX_SCTP_CHECKSUM_OFFLOAD) {
-            netdev->ol_flags |= NETDEV_TX_OFFLOAD_SCTP_CSUM;
+            netdev->ol_flags |= NETDEV_OFFLOAD_TX_SCTP_CSUM;
         }
     }
 
@@ -5084,11 +5084,11 @@ netdev_dpdk_vhost_client_reconfigure(struct netdev *netdev)
         }
 
         if (userspace_tso_enabled()) {
-            netdev->ol_flags |= NETDEV_TX_OFFLOAD_TCP_TSO;
-            netdev->ol_flags |= NETDEV_TX_OFFLOAD_TCP_CSUM;
-            netdev->ol_flags |= NETDEV_TX_OFFLOAD_UDP_CSUM;
-            netdev->ol_flags |= NETDEV_TX_OFFLOAD_SCTP_CSUM;
-            netdev->ol_flags |= NETDEV_TX_OFFLOAD_IPV4_CSUM;
+            netdev->ol_flags |= NETDEV_OFFLOAD_TX_TCP_TSO;
+            netdev->ol_flags |= NETDEV_OFFLOAD_TX_TCP_CSUM;
+            netdev->ol_flags |= NETDEV_OFFLOAD_TX_UDP_CSUM;
+            netdev->ol_flags |= NETDEV_OFFLOAD_TX_SCTP_CSUM;
+            netdev->ol_flags |= NETDEV_OFFLOAD_TX_IPV4_CSUM;
             vhost_unsup_flags = 1ULL << VIRTIO_NET_F_HOST_ECN
                                 | 1ULL << VIRTIO_NET_F_HOST_UFO;
         } else {
diff --git a/lib/netdev-linux.c b/lib/netdev-linux.c
index 3cf02b76a..129043812 100644
--- a/lib/netdev-linux.c
+++ b/lib/netdev-linux.c
@@ -928,11 +928,11 @@ netdev_linux_common_construct(struct netdev *netdev_)
     ovs_mutex_init(&netdev->mutex);
 
     if (userspace_tso_enabled()) {
-        netdev_->ol_flags |= NETDEV_TX_OFFLOAD_TCP_TSO;
-        netdev_->ol_flags |= NETDEV_TX_OFFLOAD_TCP_CSUM;
-        netdev_->ol_flags |= NETDEV_TX_OFFLOAD_UDP_CSUM;
-        netdev_->ol_flags |= NETDEV_TX_OFFLOAD_SCTP_CSUM;
-        netdev_->ol_flags |= NETDEV_TX_OFFLOAD_IPV4_CSUM;
+        netdev_->ol_flags |= NETDEV_OFFLOAD_TX_TCP_TSO;
+        netdev_->ol_flags |= NETDEV_OFFLOAD_TX_TCP_CSUM;
+        netdev_->ol_flags |= NETDEV_OFFLOAD_TX_UDP_CSUM;
+        netdev_->ol_flags |= NETDEV_OFFLOAD_TX_SCTP_CSUM;
+        netdev_->ol_flags |= NETDEV_OFFLOAD_TX_IPV4_CSUM;
     }
 
     return 0;
diff --git a/lib/netdev-provider.h b/lib/netdev-provider.h
index 08bf8b871..0a8538615 100644
--- a/lib/netdev-provider.h
+++ b/lib/netdev-provider.h
@@ -38,11 +38,11 @@ struct netdev_tnl_build_header_params;
 #define NETDEV_NUMA_UNSPEC OVS_NUMA_UNSPEC
 
 enum netdev_ol_flags {
-    NETDEV_TX_OFFLOAD_IPV4_CSUM = 1 << 0,
-    NETDEV_TX_OFFLOAD_TCP_CSUM = 1 << 1,
-    NETDEV_TX_OFFLOAD_UDP_CSUM = 1 << 2,
-    NETDEV_TX_OFFLOAD_SCTP_CSUM = 1 << 3,
-    NETDEV_TX_OFFLOAD_TCP_TSO = 1 << 4,
+    NETDEV_OFFLOAD_TX_IPV4_CSUM = 1 << 0,
+    NETDEV_OFFLOAD_TX_TCP_CSUM = 1 << 1,
+    NETDEV_OFFLOAD_TX_UDP_CSUM = 1 << 2,
+    NETDEV_OFFLOAD_TX_SCTP_CSUM = 1 << 3,
+    NETDEV_OFFLOAD_TX_TCP_TSO = 1 << 4,
 };
 
 /* A network device (e.g. an Ethernet device).
diff --git a/lib/netdev.c b/lib/netdev.c
index e9b2bbe83..a06138aca 100644
--- a/lib/netdev.c
+++ b/lib/netdev.c
@@ -795,7 +795,7 @@ netdev_send_prepare_packet(const uint64_t netdev_flags,
     uint64_t l4_mask;
 
     if (dp_packet_hwol_is_tso(packet)
-        && !(netdev_flags & NETDEV_TX_OFFLOAD_TCP_TSO)) {
+        && !(netdev_flags & NETDEV_OFFLOAD_TX_TCP_TSO)) {
             /* Fall back to GSO in software. */
             VLOG_ERR_BUF(errormsg, "No TSO support");
             return false;
@@ -804,19 +804,19 @@ netdev_send_prepare_packet(const uint64_t netdev_flags,
     l4_mask = dp_packet_hwol_l4_mask(packet);
     if (l4_mask) {
         if (dp_packet_hwol_l4_is_tcp(packet)) {
-            if (!(netdev_flags & NETDEV_TX_OFFLOAD_TCP_CSUM)) {
+            if (!(netdev_flags & NETDEV_OFFLOAD_TX_TCP_CSUM)) {
                 /* Fall back to TCP csum in software. */
                 VLOG_ERR_BUF(errormsg, "No TCP checksum support");
                 return false;
             }
         } else if (dp_packet_hwol_l4_is_udp(packet)) {
-            if (!(netdev_flags & NETDEV_TX_OFFLOAD_UDP_CSUM)) {
+            if (!(netdev_flags & NETDEV_OFFLOAD_TX_UDP_CSUM)) {
                 /* Fall back to UDP csum in software. */
                 VLOG_ERR_BUF(errormsg, "No UDP checksum support");
                 return false;
             }
         } else if (dp_packet_hwol_l4_is_sctp(packet)) {
-            if (!(netdev_flags & NETDEV_TX_OFFLOAD_SCTP_CSUM)) {
+            if (!(netdev_flags & NETDEV_OFFLOAD_TX_SCTP_CSUM)) {
                 /* Fall back to SCTP csum in software. */
                 VLOG_ERR_BUF(errormsg, "No SCTP checksum support");
                 return false;